 /*==========================================================================
                SeqAn - The Library for Sequence Analysis
                          http://www.seqan.de 
 ============================================================================
  Copyright (C) 2007

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 3 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  Lesser General Public License for more details.

 ============================================================================
  $Id: graph_algorithms.h 1901 2008-04-28 13:07:56Z rausch@PCPOOL.MI.FU-BERLIN.DE $
 ==========================================================================*/

#ifndef SEQAN_HEADER_GRAPH_ALGORITHMS_H
#define SEQAN_HEADER_GRAPH_ALGORITHMS_H

// External / STL
#include <set>
#include <queue>

// Seqan
#include <seqan/graph_types.h>
#include <seqan/misc/misc_random.h>

#ifdef SEQAN_SWITCH_USE_FORWARDS
#include <seqan/graph_algorithms/graph_algorithms_generated_forwards.h>
#endif

// Graph algorithms
#include <seqan/graph_algorithms/graph_algorithm_heap_tree.h>
#include <seqan/graph_algorithms/graph_algorithm.h>
#include <seqan/graph_algorithms/graph_algorithm_hmm.h>
#include <seqan/graph_algorithms/graph_algorithm_lis_his.h>


#endif //#ifndef SEQAN_HEADER_...
